require 'json'
require 'thermostat.rb'
require 'convert.rb'

class JSONThermostat
  attr_reader :thermostat, :convert
  # Initialize method that created new convert object,
  # converts the temperature and gives values to thermostat
  # @param setting [String] gets the settings in string
  def initialize(settings = ' ')
    obj = JSON.parse(settings)
    convert = Convert.new
    temperature = convert.convert(obj['temperature'], obj['unit'])
    @thermostat = Thermostat.new(temperature, temperature, obj['range'])
  end

  # The update method will parse the json input, it will
  # get the temperature and unit.
  # A new convert object is made and it is being convert
  # and checked.
  # @param json [String] gets a json string with a temperature and unit
  def update(json = ' ')
    obj = JSON.parse(json)
    temperature = obj['temperature']
    unit = obj['unit']
    convert = Convert.new
    temperature = convert.convert(obj['temperature'], obj['unit'])
    @thermostat.put_temperature(temperature)
    @thermostat.check
    return generate_Json
  end

  # This method will generate Json values
  def generate_Json
    JSON.generate(cooling: @thermostat.airco, heating: @thermostat.heating)
  end
end
